<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\Get;
use App\Entity\Hardware;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'Hardware')]
final class HardwareOutput extends AbstractOutput
{
    #[Groups(['hardware:read'])]
    public string $name;

    #[Groups(['hardware:read'])]
    public ?string $description = '';

    #[Groups(['hardware:read'])]
    public ?string $type = '';

    #[Groups(['hardware:read'])]
    public \DateTime $createAt;

    #[Groups(['hardware:read'])]
    public ?string $createBy = null;

    public function __construct(Hardware $hardware)
    {
        parent::__construct($hardware);

        $this->name = $hardware->getName();
        $this->description = $hardware->getDescription();
        $this->type = $hardware->getType();
        $this->createAt = $hardware->getCreatedAt();
        $this->createBy = $hardware->getCreatedBy();
    }
}